/**

	BrainFuck Compiler
	
	File			:	Compiler Definition

	Created by		:	Reznichenko Anton aka AlterVision
						mailto:me@av13.ru
						http://www.av13.ru

	Project started :	29 november 2008 - 01:14
	Last edited		:	29 november 2008 - 01:46

	Describtion		:
		
		This is the first, and I hope, the only version of my brainfuck compiler.

		The brainfuck language is an esoteric programming language noted 
		for its extreme minimalism. It was designed to challenge and amuse 
		programmers, and is not suitable for practical use. 

		For more information, read: 
			All info	:	http://www.av13.ru/arts/brainfuck/
			Language	:	http://www.av13.ru/arts/brainfuck/#language
			Examples	:	http://www.av13.ru/arts/brainfuck/#examples

		Great thanks at all to Gensek (Ostrecov D.) for his advices, beer and 
		my girlfriend for the inspiration. Without you it would be impossible.

	License				:	GNU GLP
	License notice		:	Please, do not use this product! It can cause 
							possible injures and brain problems!
							I told you!!						

*/

#define null NULL
#define true 1
// #define true false //  , !?

#define BRAINFUCKS	65532

#define TK_COUNT	8
#define TK_NEXT		'>'
#define	TK_PREV		'<'
#define	TK_INC		'+'
#define	TK_DEC		'-'
#define	TK_OUT		'.'
#define TK_IN		','
#define	TK_STR		'['
#define	TK_END		']'

typedef struct _stack stack_t, *stack_p;
struct _stack {
	int					command;
	stack_p				next;
};

typedef struct _brainfuck {
	int					ptr;
	unsigned short int	data[BRAINFUCKS];
	int					commands;
	int					pos;
	char				code[BRAINFUCKS];
	stack_t *			stack;
} brainfuck_t;

int brainfuck ( char * );