/**

	BrainFuck Compiler
	
	File			:	Console Controller

	Created by		:	Reznichenko Anton aka AlterVision
						mailto:me@av13.ru
						http://www.av13.ru

	Project started :	29 november 2008 - 01:08
	Last edited		:	29 november 2008 - 01:14

	Describtion		:
		
		This is the first, and I hope, the only version of my brainfuck compiler.

		The brainfuck language is an esoteric programming language noted 
		for its extreme minimalism. It was designed to challenge and amuse 
		programmers, and is not suitable for practical use. 
		
		For more information, read: 
			All info	:	http://www.av13.ru/arts/brainfuck/
			Language	:	http://www.av13.ru/arts/brainfuck/#language
			Examples	:	http://www.av13.ru/arts/brainfuck/#examples

		Great thanks at all to Gensek (Ostrecov D.) for his advices, beer and 
		my girlfriend for the inspiration. Without you it would be impossible.

	License				:	GNU GLP
	License notice		:	Please, do not use this product! It can cause 
							possible injures and brain problems!
							I told you!!						

*/

#define null NULL
#define true 1

#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include "compiler.h"

int main ( void ) {

	// Commands Definition :: Start

	#define COMMANDS	7
	#define EXIT_C		0
	#define ABOUT_C		1
	#define RUN_C		2
	#define CLS_C		3
	#define HELP_C		4

	typedef struct _command {
		int		code;
		char	name[20];
	} command_t;

	command_t commands[COMMANDS] = {
			{ABOUT_C,	"about"},		// About program
			{EXIT_C,	"exit"},		// Exit program
			{RUN_C,		"run"},			// Run file
			{CLS_C,		"cls"},			// Clear Screen
			{HELP_C,	"help"},		// Help command
			{HELP_C,	"man"},			// Help alias
			{HELP_C,	"google"}		// Idiot help alias (... use google, Luke ...)
	};

	// Command Definition :: End

	char command_prompt[255];
	char *command;
	int work_code, command_code, command_help_code, help_attempts = 0, i;

	printf("Welcome to BrainFuck Compiler (by AlterVision)\n");
	printf("For help, please type \"help\" to get list of known commands\n");

	work_code = 1;
	while (work_code) {

		// Asking for Command String
		printf("# ");
		gets(command_prompt);

		// Checking Command
		command_code = -1;
		if (strlen(command_prompt)) {
				command = strtok (command_prompt, " "); 
			for (i = 0; i < COMMANDS; i++) {	
				if (strcmp(command, commands[i].name) == 0) {	
					command_code = commands[i].code;
					break;
				}
			}
		}

		// Running Specified Command
		switch (command_code) {

			case ABOUT_C:
				printf("  Small Compiler, version 0.1\n");
				printf("  Created by Anton Reznichenko aka ALterVision\n");
				break;

			case CLS_C:
				system("cls");
				break;

			case RUN_C:
				command = strtok( NULL, " " );
				brainfuck (command);
				break;

			case HELP_C:
				command = strtok( NULL, " " );
				command_help_code = -1;
				if (command != NULL) {
					for (i = 0; i < COMMANDS; i++) {	
						if (strcmp(command, commands[i].name) == 0) {	
							command_help_code = commands[i].code;	break;
						}
					}
				}
				printf("\n");
				switch (command_help_code) {

					case ABOUT_C:
						printf("  Help: about command\n");
						printf("   Types about prorgam information, e.g version\n");
						break;

					case CLS_C:
						printf("  Help: cls command\n");
						printf("   Clears the command screen\n");
						break;

					case EXIT_C:
						printf("  Help: exit command\n");
						printf("   Exits the program\n");
						break;

					case RUN_C:
						printf("  Help: run command\n");
						printf("   Compiles and runs the file, sent as parameter\n\n");
						printf("  Syntaxis:\n");
						printf("   run path_to_the_file\n\n");
						printf("  Notice:\n");
						printf("   Doublecheck the file - errors are too possible\n");
						if (help_attempts > 3) printf("   Please, use \"google\" before asking dumb questions ...\n\n");
						break;					
				
					case HELP_C:
						printf("  Help: help command\n");
						help_attempts++;
						if (help_attempts < 4) {
							printf("   Shows the help, you are reading now.\n");
							printf("   Notice, recursion sometimes kills\n");
						} else {
							printf("  Are you f*cking stupid!? You are asking for too many times!!\n");
							printf("  Type %d times:\n", help_attempts);
							for (i = 0; i < help_attempts; i++) {
								printf("\tI will use google before asking dumb questions!!\n");
							}
							printf("\tI will use this f*cking google before asking dumb questions!!\n");
							printf("  Understand?\n");
						}
						break;

					default:
						printf("  Console Commands: \n\n\t run\n\t about\n\t cls\n\t exit\n\t help\n\n");
						printf("  To get fuller help, type \"help command\"\n");
					
				}
				printf("\n");
				break;

			case EXIT_C:
				printf("  Good bye!\n");
				work_code = 0;
				break;

			default:
				printf("  Unknown command\n");

		}


	}

    return 0;

}